unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqlite3conn, sqldb, db, FileUtil, Forms, Controls,
  Graphics, Dialogs, DbCtrls, DBGrids;

type

  { TForm1 }

  TForm1 = class(TForm)
    DBMemo1: TDBMemo;
    DsSales: TDataSource;
    DsArticles: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    SQLite3Connection1: TSQLite3Connection;
    QrySales: TSQLQuery;
    QryArticles: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure FormCreate(Sender: TObject);
  private
    procedure CreateTables;
    procedure PopulateTables;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  DB_NAME = 'test.sqlite';

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  SQLite3Connection1.DatabaseName := DB_NAME;
  DBMemo1.DataField := 'Comments';
  if not FileExists(DB_NAME) then begin
    //SQLite3Connection1.Connected := false;
    CreateTables;
    PopulateTables;
  end;
  SQLite3Connection1.Connected := true;
  QryArticles.SQL.Add('SELECT * FROM Articles');
  QryArticles.Open;
  QrySales.SQL.Add('SELECT * FROM Sales');
  QrySales.Open;

end;

procedure TForm1.CreateTables;
begin
  SQLTransaction1.StartTransaction;
  SQLite3Connection1.Connected := true;
  SQLite3Connection1.ExecuteDirect('CREATE TABLE Articles (' +
    'ArticleID INTEGER UNIQUE NOT NULL, '+
    'ArticleName VARCHAR(50), '+
    'Comments TEXT, '+
    'Price FLOAT)');
  SQLite3Connection1.ExecuteDirect('CREATE TABLE Sales ('+
    'ArticleID INTEGER NOT NULL, '+
    'PiecesSold INTEGER NOT NULL, '+
    'DateSold DATE NOT NULL)');
  SQLTransaction1.Commit;
  SQLite3Connection1.Connected := false;
end;

procedure TForm1.PopulateTables;
const
  N = 5;
var
  i, j: Integer;
  id: Integer;
  m: Integer;
  s: String;
  sc: String;
  p: Double;
  fs: TFormatSettings;
  dt: TDate;
begin
  SQLTransaction1.StartTransaction;
  fs := FormatSettings;
  fs.DecimalSeparator := '.';
  for i:=0 to N-1 do begin
    id := Random(100000);
    p := Random * 1000;
    SetLength(s, 3 + Random(5));
    for j:=1 to Length(s) do
      s[j] := char(Random(26) + ord('A'));
    sc := IntToStr(i) + LineEnding +
      'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.';
    SQLite3Connection1.ExecuteDirect(Format(
      'INSERT INTO Articles (ArticleID, ArticleName, Comments, Price) VALUES (%d, "%s", "%s", %.2f)', [
      id, s, sc, p
    ], fs));
    for j:=0 to 10*n-1 do begin
      m := random(10) + 1;
      dt := SysUtils.Date() - 1000 + Random * 1000;
      SQLite3Connection1.ExecuteDirect(Format(
        'INSERT INTO Sales (ArticleID, PiecesSold, DateSold) VALUES (%d, %d, %s)',
        [id, m, FormatDateTime('yyyymmdd', dt)
      ]));;
    end;
  end;
  SQLTransaction1.Commit;
end;

end.

